<?php
/*
Plugin Name: SILO Bot Elite
Plugin URI: http://seointerlink.org
Description: Interlinks the whole site for SEO.
Version: 1.0
License: GPLv2
Author: KME Byrne And  Craig Mako
Author URI: http://seointerlink.org
*/
/* Adding css and js in admin */
function silo_blot_elite_add_admin_css_js() {

	wp_enqueue_style( 'silo_blot_elite-farbtasticcss', plugins_url( '/css/farbtastic.css' , __FILE__ ) );
	//wp_enqueue_script( 'silo_blot_elite-jqueryjs', plugins_url( '/js/jquery.js' , __FILE__ ) );
    wp_deregister_script( 'jquery' );
    wp_register_script( 'jquery', 'http://ajax.googleapis.com/ajax/libs/jquery/1.7.2/jquery.min.js');
    wp_enqueue_script( 'jquery' );
	wp_enqueue_script( 'silo_blot_elite-farbtasticjs', plugins_url( '/js/farbtastic.js' , __FILE__ ) );
	
	
}
//hook for admin css and js
add_action( 'admin_enqueue_scripts', 'silo_blot_elite_add_admin_css_js' );



add_filter('the_content','nullcontent',1);
function nullcontent($content){
$m_keyword = get_option('SiloBlotElite_silo_blot_elite_m_keyword');
$input_keyword= get_option('SiloBlotElite_silo_blot_elite_input_keyword');
add_filter('the_content', 'replace_linktitle');
add_filter('the_excerpt', 'replace_linktitle');
$content=$content;

//silo_blot_elite_related_inputkeyword($content);
return $content;
}

//This is hook for change link to main keyword
function replace_linktitle($linktextchange){
		
	global $post;
	$input_keyword= get_option('SiloBlotElite_silo_blot_elite_input_keyword');
	$set_limit = get_option('SiloBlotElite_silo_blot_elite_limit_word_count');
	$limit=$set_limit['text_string'];
	
	$inkeyword=$input_keyword['text_string'];
	$thisposttitle=get_the_title($post->ID);
	$thisposttype=get_post_type($post->ID);
	
	$m_keyword = get_option('SiloBlotElite_silo_blot_elite_m_keyword');
	$main_keyword=$m_keyword['text_string'];
	$m_k_url = get_option('SiloBlotElite_silo_blot_elite_m_k_url');
	
	$link_color = get_option('SiloBlotElite_silo_blot_elite_link_color');
	$link_nofollows = get_option('SiloBlotElite_silo_blot_elite_noflows');
	$l_color=$link_color['text_string'];
	$l_nofollows=$link_nofollows['text_string'];
	//this is test code for page
	$pages = get_pages(); 
	  foreach ( $pages as $page ) {
		//$option =  get_page_link( $page->ID ).$page->post_title;
		if(!empty($page->post_title)){
			 $title1=$page->post_title;
		   if($title1==$main_keyword){
			  if($main_keyword==$thisposttitle){
			   //{above two if conditions} This code is Exactly Matching of the title of Page.
	       //if(contains(strtolower(trim($main_keyword)), strtolower($title1))){
	            //if(contains(strtolower(trim($main_keyword)), strtolower($thisposttitle))){
				//{above two if conditions} This code for substring  Exactly Matching to the  title of page.
				 $linktextchange=$linktextchange;
				}else{
				  $link=get_page_link( $page->ID );
				  $result = ReplaceKeywordWithLink($linktextchange, $main_keyword,$link ,$l_color,$l_nofollows);
				  $linktextchange=$result; 
				  }
		   }
		}
	}
	
	$args=array(
	      'post_type'=> array('post'),
		  'caller_get_posts'=>1
		);
	
	$my_query = new WP_Query($args);
    if( $my_query->have_posts() ) {
     while ($my_query->have_posts()) : $my_query->the_post();
	  if(!empty($post->post_title)){ 
	   $title=$post->post_title;
	    if($title==$main_keyword){
	       if($main_keyword==$thisposttitle){
		   //{above two if conditions} This code is Exactly Matching of the title of post. 
		  //if(contains(strtolower(trim($main_keyword)), strtolower($title))){
	          //if(contains(strtolower(trim($main_keyword)), strtolower($thisposttitle))){                //{above two if conditions} This code for substring  Exactly Matching to the  title of post.
		    ?>
			<!--<p><a href="<?php the_permalink() ?>" rel="bookmark" title="Permanent Link to <?php the_title_attribute(); ?>"><?php the_title(); ?></a></p><br/>-->
		   <?php
		    $linktextchange=$linktextchange;
			}else{
			  $link=esc_url( get_permalink( get_page_by_title( $main_keyword ) ) );
			  $result = ReplaceKeywordWithLink($linktextchange, $main_keyword,$link ,$l_color,$l_nofollows); 
			 $linktextchange=$result;  
			}
		 }
	   }
	  endwhile;
    } //if ($my_query)
wp_reset_query();
		
return $linktextchange;

}

//This is function for skiping <a> tag from string
function ReplaceKeywordWithLink($html, $keyword, $link,$l_color,$l_nofollows)
{
    if (strpos($html, "<") !== false) {
        $id = 0;
        $unique_array = array();
        // Hide existing anchor tags with some unique string.
        preg_match_all("#<a[^<>]*>[\s\S]*?</a>#i", $html, $matches);
        foreach ($matches[0] as $tag) {
            $id++;
            $unique_string = "@@@@@$id@@@@@";
            $unique_array[$unique_string] = $tag;
            $html = str_replace($tag, $unique_string, $html);
        }
        // Hide all tags by replacing with some unique string.
        preg_match_all("#<[^<>]+>#", $html, $matches);      
        foreach ($matches[0] as $tag) {
            $id++;
            $unique_string = "@@@@@$id@@@@@";
            $unique_array[$unique_string] = $tag;
            $html = str_replace($tag, $unique_string, $html);
        }
    }
    // Then we replace the keyword with link.
    $keyword = preg_quote($keyword);
    assert(strpos($keyword, '$') === false);
	    
	    if($l_nofollows=='yes'){
		 $html = preg_replace('#(\b)('.$keyword.')(\b)#i', '$1<a href="'.$link.'" style="color:'.$l_color.';" rel="nofollow">$2</a>$3', $html);
		}
		else{
		  $html = preg_replace('#(\b)('.$keyword.')(\b)#i', '$1<a href="'.$link.'" style="color:'.$l_color.';">$2</a>$3', $html);
		}
    // We get back all the tags by replacing unique strings with their corresponding tag.
    if (isset($unique_array)) {     
        foreach ($unique_array as $unique_string => $tag) {
            $html = str_replace($unique_string, $tag, $html);
        }
    }
    return $html;
}


//This is function for skiping <a> tag from string with limit
function ReplaceKeywordWithLink_withlimit($html, $keyword, $link,$l_color,$l_nofollows,$limit)
{
    if (strpos($html, "<") !== false) {
        $id = 0;
        $unique_array = array();
        // Hide existing anchor tags with some unique string.
        preg_match_all("#<a[^<>]*>[\s\S]*?</a>#i", $html, $matches);
        foreach ($matches[0] as $tag) {
            $id++;
            $unique_string = "@@@@@$id@@@@@";
            $unique_array[$unique_string] = $tag;
            $html = str_replace($tag, $unique_string, $html);
        }
        // Hide all tags by replacing with some unique string.
        preg_match_all("#<[^<>]+>#", $html, $matches);      
        foreach ($matches[0] as $tag) {
            $id++;
            $unique_string = "@@@@@$id@@@@@";
            $unique_array[$unique_string] = $tag;
            $html = str_replace($tag, $unique_string, $html);
        }
    }
    // Then we replace the keyword with link.
    $keyword = preg_quote($keyword);
    assert(strpos($keyword, '$') === false);
	    
	    if($l_nofollows=='yes'){
		 $html = preg_replace('#(\b)('.$keyword.')(\b)#i', '$1<a href="'.$link.'" style="color:'.$l_color.';" rel="nofollow">$2</a>$3', $html,$limit);
		}
		else{
		  $html = preg_replace('#(\b)('.$keyword.')(\b)#i', '$1<a href="'.$link.'" style="color:'.$l_color.';">$2</a>$3', $html,$limit);
		}
    // We get back all the tags by replacing unique strings with their corresponding tag.
    if (isset($unique_array)) {     
        foreach ($unique_array as $unique_string => $tag) {
            $html = str_replace($unique_string, $tag, $html);
        }
    }
    return $html;
}



//hook For repalceing Input keywords with link on number of occurrence
//This hook call all input keywords and search on page or post content exclude than 
//itself and replace word with appropriate link. 
add_filter('the_content', 'silo_blot_elite_related_inputkeyword');
add_filter('the_excerpt', 'silo_blot_elite_related_inputkeyword');
function silo_blot_elite_related_inputkeyword($textchange){

	
	global $post;
	$input_keyword= get_option('SiloBlotElite_silo_blot_elite_input_keyword');
	$set_limit = get_option('SiloBlotElite_silo_blot_elite_limit_word_count');
	$limit=$set_limit['text_string'];
	$inkeyword=$input_keyword['text_string'];
	$thisposttitle=trim(get_the_title($post->ID));
	$thisposttype=get_post_type($post->ID);
	
	$link_color = get_option('SiloBlotElite_silo_blot_elite_link_color');
	$link_nofollows = get_option('SiloBlotElite_silo_blot_elite_noflows');
	$l_color=$link_color['text_string'];
	$l_nofollows=$link_nofollows['text_string'];
	
	$m_keyword = get_option('SiloBlotElite_silo_blot_elite_m_keyword');
	$main_keyword=$m_keyword['text_string'];
	$inputkeyword=explode(',',$inkeyword);
	$inarray1=array();
	$inarray2=array();
	foreach($inputkeyword as $in->value){
	      $pos=strpos($in->value,'-');
	      if ($pos === false) {
	         $inarray1[]=$in->value;
		  }else{
		     $inarray2[]=$in->value;
		  }
	}
	//usort($inarray2,'sorting');
	$result = array_merge((array)$inarray2, (array)$inarray1);
	$inputkeyword=(array)$result;
	for($i=0;$i<=count($inputkeyword);$i++){
	 
	if($main_keyword!=''){
	//This is code for replace page title 
	$pages = get_pages(); 
	  foreach ( $pages as $page ) {
		if(!empty($page->post_title)){
			 $title1=trim($page->post_title);
		    //if($title1==trim($inputkeyword[$i])){
				//if(trim($inputkeyword[$i])==$thisposttitle){
				//{above two if conditions} This code is Exactly Matching of the title of post. 
		     if(contains(strtolower(trim($inputkeyword[$i])), strtolower($title1))){
				if(contains(strtolower(trim($inputkeyword[$i])), strtolower($thisposttitle))){
				//{above two if conditions} This code for substring  Exactly Matching to the  title of post.	
				
				  $textchange=$textchange;
				}else{
				  $link=get_page_link( $page->ID );
				  $result =ReplaceKeywordWithLink_withlimit( $textchange, trim($inputkeyword[$i]),$link ,$l_color,$l_nofollows,$limit);
				  $textchange=$result;
			  }
		   }
		 }
	   }
	 }
	 $args=array(
	      'post_type'=> array('post'),
		  'caller_get_posts'=>1
		);
	$my_query = new WP_Query($args);
    if( $my_query->have_posts() ) {
      //echo substr_count($textchange, $inkeyword);
	  while ($my_query->have_posts()) : $my_query->the_post();
	  if(!empty($post->post_title)){ 
	   $title=trim($post->post_title);
	   // if($title==trim($inputkeyword[$i])){
	     //if(trim($inputkeyword[$i])==$thisposttitle){
	  if(contains(strtolower(trim($inputkeyword[$i])), strtolower($title))){
	     
	       if(contains(strtolower(trim($inputkeyword[$i])), strtolower($thisposttitle))){	             $textchange=$textchange;
			}else{
			 //echo trim($inputkeyword[$i]).'<br/>';
			 /*if($l_nofollows=='yes'){
			 $textchange =preg_replace('/'.trim($inputkeyword[$i]).'/', '<a href="'.esc_url( get_permalink( get_page_by_title( trim($inputkeyword[$i]) ) ) ).'"  style="color:'.$l_color.'" rel="nofollow" >'.trim($inputkeyword[$i]).'</a>', $textchange, $limit);             
			 }else{
			 $textchange =preg_replace('/'.trim($inputkeyword[$i]).'/', '<a  href="'.esc_url( get_permalink( get_page_by_title(trim($inputkeyword[$i]) ) ) ).'"  style="color:'.$l_color.'" >'.trim($inputkeyword[$i]).'</a>', $textchange, $limit);
			 } */  
			
			 $link= esc_url( get_permalink( get_page_by_title( trim($inputkeyword[$i]) ) ) );
			 $result =ReplaceKeywordWithLink_withlimit( $textchange, trim($inputkeyword[$i]),$link ,$l_color,$l_nofollows,$limit);
			 $textchange=$result;
			}
		 }
	   }
	  endwhile;
    } //if ($my_query)
    wp_reset_query();
	}//End For //if ($my_query)

return $textchange;
}
function contains($substring, $string) {
        $pos = @strpos($string, $substring);
 
        if($pos===false) {
                // string NOT found
                return false;
        }
        else {
                // string found
                return true;
        }
}
function sorting($a,$b){
    return strlen($b)-strlen($a);
}
//hook for "all related links"
add_filter('the_content', 'silo_blot_elite_add_post_content',11);
function silo_blot_elite_add_post_content($content) {
    $m_keyword = get_option('SiloBlotElite_silo_blot_elite_m_keyword');
    $m_k_url = get_option('SiloBlotElite_silo_blot_elite_m_k_url');
    
    $s1_keyword = get_option('SiloBlotElite_silo_blot_elite_s1_keyword');
    $s1_k_url = get_option('SiloBlotElite_silo_blot_elite_s1_k_url');
    
    $s2_keyword = get_option('SiloBlotElite_silo_blot_elite_s2_keyword');
    $s2_k_url = get_option('SiloBlotElite_silo_blot_elite_s2_k_url');
    
    $aff_keyword = get_option('SiloBlotElite_silo_blot_elite_aff_keyword');
    $aff_k_url = get_option('SiloBlotElite_silo_blot_elite_aff_k_url');
	//additional settings
	$re_heading_text = get_option('SiloBlotElite_silo_blot_elite_re_heading_text');
	$re_heading_color = get_option('SiloBlotElite_silo_blot_elite_re_heading_color');
	$link_color = get_option('SiloBlotElite_silo_blot_elite_link_color');
	$link_noflows = get_option('SiloBlotElite_silo_blot_elite_noflows');
	$enable_on = get_option('SiloBlotElite_silo_blot_elite_enable_on');
	
	$input_keyword= get_option('SiloBlotElite_silo_blot_elite_input_keyword');
	$set_limit = get_option('SiloBlotElite_silo_blot_elite_limit_word_count');
    //if(!is_front_page()){
    if($enable_on['text_string'] == get_post_type() || $enable_on['text_string'] == 'both'){
	$content .="<style type='text/css'>
				#seolinksdiv h3{
				color:".$re_heading_color['text_string'].";
				}
				#seolinksdiv ul li a{
				color:".$link_color['text_string'].";
				}
				.form-table td {width: 0px;}
				</style>";
	$content .= '<div id="seolinksdiv">';  
	if($re_heading_text['text_string']!='') {
	   $content .='<h3>' .$re_heading_text['text_string']. '</h3><ul>';
	}else {
	   $content .= '<h3>Recommended Reading</h3><ul>';
	}
	if($link_noflows['text_string']=='yes'){//if nofollow allows 
		if($m_keyword['text_string']!='' && !is_front_page()) {	
		  $content .= '<li><a href="'.$m_k_url['text_string'].'" rel="nofollow">'.$m_keyword['text_string'].'</a></li>'; 
		}
		
		if($s1_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	
		$content .= '<li><a href="' . $s1_k_url['text_string'] . '" rel="nofollow">' . $s1_keyword['text_string'] . '</a></li>'; 
		}
		if($s2_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	
		$content .= '<li><a href="' . $s2_k_url['text_string'] . '" rel="nofollow">' . $s2_keyword['text_string'] . '</a></li>'; }
		$content .= silo_blot_elite_related_posts();
		if($aff_keyword['text_string']!='') {	
		   $content .= '<li><a href="' . $aff_k_url['text_string'] . '" rel="nofollow">' . $aff_keyword['text_string'] . '</a></li>'; }
		}
	else{//if rel='nofollow' not allows 
	    if($m_keyword['text_string']!='' && !is_front_page()) {	
		$content .= '<li><a href="' . $m_k_url['text_string'] . '">' . $m_keyword['text_string'] . '</a></li>'; 
		}
		
		if($s1_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	$content .= '<li><a href="' . $s1_k_url['text_string'] . '">' . $s1_keyword['text_string'] . '</a></li>'; }
		
		if($s2_keyword['text_string']!='' && get_post_type()!='post' && !is_page() || is_front_page()) {	$content .= '<li><a href="' . $s2_k_url['text_string'] . '">' . $s2_keyword['text_string'] . '</a></li>'; }
		$content .= silo_blot_elite_related_posts();
		if($aff_keyword['text_string']!='') {	
		$content .= '<li><a href="' . $aff_k_url['text_string'] . '">' . $aff_keyword['text_string'] . '</a></li>'; }
	}	   
	    $content .= '</ul></div>';
	}
	//}
	
    return $content;
}

function silo_blot_elite_related_posts(){

$orig_post = $post;
global $post;

$cat_or_tag= get_option('SiloBlotElite_silo_blot_elite_cat_tag');
$cat_tag_no = get_option('SiloBlotElite_silo_blot_elite_related_count');
      

if($cat_or_tag['text_string']=='tags'){

$tags = wp_get_post_tags($post->ID);
if ($tags) {
$tag_ids = array();
foreach($tags as $individual_tag) $tag_ids[] = $individual_tag->term_id;
$args=array(
'tag__in' => $tag_ids,
'post__not_in' => array($post->ID),
'posts_per_page'=>$cat_tag_no['text_string'], // Number of related posts that will be shown.
'caller_get_posts'=> 1
);
}
}
else{
$categories = get_the_category($post->ID);
if ($categories) {
$category_ids = array();
foreach($categories as $individual_category) $category_ids[] = $individual_category->term_id;

$args=array(
'category__in' => $category_ids,
'post__not_in' => array($post->ID),
'posts_per_page'=> $cat_tag_no['text_string'], // Number of related posts that will be shown.
'caller_get_posts'=> 1
);
}
}

$my_query = new wp_query( $args );
if( $my_query->have_posts() ) {
$related_posts = '';
while( $my_query->have_posts() ) {
$my_query->the_post();

$related_posts .= '<li><a href="' . get_permalink() . '" rel="bookmark" title="' . get_the_title() . '">' . get_the_title() . '</a></li>';
}

}
$post = $orig_post;
wp_reset_query();
		  /*$pages = get_pages(); 
		  foreach ( $pages as $page ) {
			if(!empty($page->post_title)){
					  $related_posts .= '<li><a href="' . get_page_link( $page->ID ) . '" rel="bookmark" title="' . $page->post_title . '">' . $page->post_title . '</a></li>';
					  
				  }
		    }*/
return $related_posts;

}

//  * Full details of how to use Settings see here: http://codex.wordpress.org/Settings_API
class silo_blot_elite_settings_config {
 
// MAIN CONFIGURATION SETTINGS
 
var $group = "SiloBlotElite"; // defines setting groups (should be bespoke to your settings)
var $page_name = "silo_blot_elite"; // defines which pages settings will appear on. Either bespoke or media/discussion/reading etc
 
//  DISPLAY SETTINGS
//  (only used if bespoke page_name)
 
var $title = "SILO Bot Elite";  // page title that is displayed
var $intro_text = "This allows you to configure the links to show under post content"; // text below title
var $nav_title = "SILO Bot Elite"; // how page is listed on left-hand Settings panel
 
//  SECTIONS
//  Each section should be own array within $sections.
//  Should contatin title, description and fields, which should be array of all fields.
//  Fields array should contain:
//  * label: the displayed label of the field. Required.
//  * description: the field description, displayed under the field. Optional
//  * suffix: displays right of the field entry. Optional
//  * default_value: default value if field is empty. Optional
//  * dropdown: allows you to offer dropdown functionality on field. Value is array listed below. Optional
//  * function: will call function other than default text field to display options. Option
//  * callback: will run callback function to validate field. Optional
//  * All variables are sent to display function as array, therefore other variables can be added if needed for display purposes
 
var $sections = array(
       'silo_blot_elite' => array(
        'title' => "Main Keyword & URL of the Site ",
        'description' => "This would be your Site URL and keyword",
         'fields' => array (
              'silo_blot_elite_m_keyword' => array (
              'label' => "Main Keyword",
              'description' => "Main Keyword for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_blot_elite_m_k_url' => array (
              'label' => "Main Keyword URL",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              )
          )
        ),
        'silo_blot_elite2' => array(
        'title' => "Secondary Keywords & URL'S",
        'description' => "Links & Keywords to the second most important posts on your site.",
         'fields' => array (
          'silo_blot_elite_s1_keyword' => array (
              'label' => "Secondary Keyword (1)",
              'description' => "Secondry Keyword 1 for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_blot_elite_s1_k_url' => array (
              'label' => "Secondary URL (1)",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              ),
           
           'silo_blot_elite_s2_keyword' => array (
              'label' => "Secondary Keyword (2)",
              'description' => "Secondry Keyword 2 for SEO",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_blot_elite_s2_k_url' => array (
              'label' => "Secondary URL (2)",
              'description' => "Link for the same",
              'length' => "3",
              'default_value' => ""
              )
           )
          ),
         'silo_blot_elite3' => array(
         'title' => "Other Settings",
         'fields' => array (
          'silo_blot_elite_enable_on' => array(
              'label' => "Enable on Posts or Pages or Both",
              'description' => "Select from dropdown",
              'dropdown' => "dd_enable",
              'default_value' => "posts"),
          'silo_blot_elite_cat_tag' => array(
              'label' => "Related Posts Links",
              'description' => "Based on Category or Tags",
              'dropdown' => "dd_cat_tag",
              'default_value' => "category"),
            'silo_blot_elite_related_count' => array(
              'label' => "Related Posts Count",
              'description' => "Choose the Number of related posts",
              'dropdown' => "dd_related",
              'default_value' => "2"),
           'silo_blot_elite_aff_keyword' => array (
              'label' => "Affiliate Keyword",
              'description' => "Optional",
              'length' => "3",
              'default_value' => ""
              ),
          'silo_blot_elite_aff_k_url' => array (
              'label' => "Affiliate Keyword URL",
              'description' => "Optional",
              'length' => "3",
              'default_value' => ""
              ),
		 )
      ),
	    'silo_blot_elite4' => array(
         'title' => "Recommended Reading Settings",
         'fields' => array (
         'silo_blot_elite_re_heading_text' => array (
		  'label' => "Change Recommended Reading Heading Text:",
		  'description' => "Choose Heading Text",
		  'length' => "3",
		  'default_value' => "Recommended Reading"
		  ),
		 
		 'silo_blot_elite_re_heading_color' => array (
		  'label' => "Change Recommended Reading Heading Text color:",
		  'description' => "Choose Heading Text color<br/><div style='width: 567px;' id='colorpicker1'></div>",
		  'length' => "3",
		  'default_value' => "#000000"
		  )
		 )
        ),
		'silo_blot_elite5' => array(
		    'title' => "Contextual Settings",
			'fields' => array (
			  'silo_blot_elite_noflows' => array (
			  'label' => "No follow",
			  'description' => "Choose No follow for your links.",
			  'dropdown' => "noflows_eanble",
			  'default_value' => "yes"
			  ),
			 'silo_blot_elite_input_keyword' => array (
			  'label' => "Input Keywords:",
			  'description' => "<div style='float:left;width:240px;margin-left:8px;'>Enter words in Comma separated format 
			  e.g.  Post title1, Post title2, Post title3...
              These words will be appear on the page or post content with appropriate links.
<div>",
			  'textarea' => "textarea",
			  'length' => "3",
			  'default_value' => ""
			  ),
			 'silo_blot_elite_limit_word_count' => array (
			  'label' => "Set Search words limit:",
			  'description' => "Set limit to each word for how many times it will appear on the page or post content with the link of form above comma separated list.",
			  'dropdown' => "set_word_limit",
			  'default_value' => "1"
			  ),
			
			  'silo_blot_elite_link_color' => array (
			  'label' => "Change link color:",
			  'description' => "Choose Link color<br/><div style='width: 567px;' id='colorpicker2'></div>",
			  'length' => "3",
			  'default_value' => "#000000"
			   )
			)
		  )
	);
 
 // DROPDOWN OPTIONS
 // For drop down choices.  Each set of choices should be unique array
 // Use key => value to indicate name => display name
 // For default_value in options field use key, not value
 // You can have multiple instances of the same dropdown options
 
var $dropdown_options = array (
    'dd_related' => array (
        '0' => '0',
        '1' => "1",
        '2' => "2",
        '3' => "3",
        '4' => "4",
        '5' => "5",
        '6' => "6"
        ),
	'set_word_limit'=> array (
        '1' => "1",
        '2' => "2",
        '3' => "3",
        '4' => "4",
        '5' => "5",
        '6' => "6",
		'7' => "7",
		'8' => "8",
		'9' => "9"
        ),	
    'dd_cat_tag' => array (
        'category' => "Category",
        'tags' => "Tags"
        ),
    'dd_enable' => array (
        'post' => "Posts",
        'page' => "Pages",
        'both' => "Both",
        ),
	'noflows_eanble' => array (
        'yes' => "yes",
        'no' => "no"
        )	
	
    );
//  end class
};
 
require_once('seo_settings.php');
 
$silo_blot_elite_settings_init = new silo_blot_elite_settings('silo_blot_elite_settings_config');

function add_category_box_on_page(){
    //add meta box
    add_meta_box('categorydiv', __('Categories'), 'post_categories_meta_box', 'page', 'side', 'low');
    add_meta_box('tagsdiv-post_tag', __('Page Tags'), 'post_tags_meta_box', 'page', 'side', 'low');
    add_action('save_post', 'booster_page_cats_tags_save_postdata');
}
 
add_action('admin_menu', 'add_category_box_on_page');
 
function booster_page_cats_tags_save_postdata( $post_id ) {
 
    $seob_post_type = $_POST['post_type'];
 
    // verify if this is an auto save routine. If it is our form has not been submitted, so we dont want
    // to do anything
    if ( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ){
 
    }else{
        // Check permissions
        if ( 'page' == $seob_post_type ) {
            if ( current_user_can( 'edit_page', $post_id ) ){
 
                $seob_post_cats = array();
 
                foreach($_REQUEST['post_category'] as $key=>$val){
                    $seob_post_cats[] = $val;
                }
                wp_set_post_categories( $post_id, $seob_post_cats );
            }
        }
    }
}
?>