<?php
function DV_generate_feed($postId) {
	query_posts(array('p' => $postId));
	if ( have_posts()) {
		the_post();
	} else return false;
	
	$postlnk = get_permalink($postId);
	ob_start();
	echo '<?xml version="1.0" encoding="iso-8859-1"?'.'>'; ?>
	<rss version="2.0" xmlns:content="http://purl.org/rss/1.0/modules/content/" xmlns:wfw="http://wellformedweb.org/CommentAPI/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:atom="http://www.w3.org/2005/Atom" >
		<channel>
			<title><?php the_title_rss() ?></title>
			<atom:link href="<?php self_link(); ?>" rel="self" type="application/rss+xml" />
			<?php if( trim( $postlnk ) == "" ) { ?>
				<link><?php the_guid(); ?></link>
			<?php } else { ?>
				<link><?php echo $postlnk; ?></link>
			<?php } ?>
			<description><![CDATA[<?php the_excerpt_rss() ?>]]></description>
			<pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', get_lastpostmodified('GMT'), false); ?></pubDate>
			<?php the_generator( 'rss2' ); ?>
			<language><?php echo get_option('rss_language'); ?></language>
			<item>
				<title><?php the_title_rss() ?></title>
				<?php if( trim( $postlnk ) == "" ) { ?>
					<link><?php the_guid(); ?></link>
				<?php } else { ?>
					<link><?php echo $postlnk; ?></link>
				<?php } ?>
				<pubDate><?php echo mysql2date('D, d M Y H:i:s +0000', get_post_time('Y-m-d H:i:s', true), false); ?></pubDate>
				<dc:creator><?php the_author() ?></dc:creator>
				<?php the_category_rss() ?>
				<guid isPermaLink="false"><?php the_guid(); ?></guid>
				<?php if( get_option('rss_use_excerpt') ) { ?>
					<description><![CDATA[<?php the_excerpt_rss() ?>]]></description>
				<?php } else { ?>
					<description><![CDATA[<?php echo preg_replace('/[^a-z0-9!, \.]/i', '',htmlentities(get_the_content())) ?>]]></description>
				<?php } ?>
				<?php if( strlen( $post->post_content ) > 0 ) { ?>
					<content:encoded><![CDATA[<?php echo preg_replace('/[^a-z0-9!, \.]/i', '',htmlentities(get_the_content())); ?>]]></content:encoded>
				<?php } else { ?>
					<content:encoded><![CDATA[<?php the_excerpt_rss() ?>]]></content:encoded>
				<?php } ?>
				<?php rss_enclosure(); ?>
			</item>
		</channel>
	</rss>
	<?php
	$feed_content = ob_get_contents();
	ob_end_clean();
	return $feed_content;
}

function DV_submit_feed( $feedPath = '', $post_title = '' ) {
	$rss_dir_list = array();
	
	$rss_dir_list[0]['url'] = 'rssfeedurl.co.cc/savefeed.php';
	$rss_dir_list[0]['post_fields'] = "category=Software&description=".urlencode($post_title)."&url=".urlencode($feedPath);
	
	$rss_dir_list[1]['url'] = 'rss.buymyscripts.net/savefeed.php';
	$rss_dir_list[1]['post_fields'] = "category=Software&description=".urlencode($post_title)."&url=".urlencode($feedPath);
	
	$rss_dir_list[2]['url'] = 'http://rss.ph/addfeed.html';
	$rss_dir_list[2]['post_fields'] = "catid=17&url=".urlencode($feedPath);
	
	$rss_dir_list[3]['url'] = 'http://rssroot.com/index.php';
	$rss_dir_list[3]['post_fields'] = "rss01en_params[]=Software&rss01en_params[]=".urlencode($feedPath)."&rss01en_params[]=";
	
	$rss_dir_list[4]['url'] = 'http://www.icerocket.com/c';
	$rss_dir_list[4]['post_fields'] = "p=addblog&url=".urlencode($feedPath);
	/*
	$rss_dir_list[5]['url'] = 'http://www.anse.de/rdfticker/addchannel.php';
	$rss_dir_list[5]['post_fields'] = "title_=".urlencode($post_title)."&description_=".urlencode($post_title)."&feedurl_=".urlencode($feedPath)."&language_=English";
	
	$rss_dir_list[6]['url'] = 'http://ngoid.sourceforge.net/add_rss.php';
	$rss_dir_list[6]['post_fields'] = "duration=30&url=".urlencode($feedPath);
	*/
	foreach( $rss_dir_list as $rss_dir ) {
		$ch = curl_init();
		curl_setopt($ch, CURLOPT_URL, $rss_dir['url']);
		curl_setopt($ch, CURLOPT_CONNECTTIMEOUT, 10);
		curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $rss_dir['post_fields']);
		$result = curl_exec($ch);
		curl_close($ch);
	}
}