<?php
class silo_blot_elite_settings {
 
function silo_blot_elite_settings($settings_class) {
    global $ob_settings;
    $ob_settings = get_class_vars($settings_class);
 
    if (function_exists('add_action')) :
      add_action('admin_init', array( &$this, 'plugin_admin_init'));
      add_action('admin_menu', array( &$this, 'plugin_admin_add_page'));
      endif;
}
 
function plugin_admin_add_page() {
  global $ob_settings;
  //add_options_page($ob_settings['title'], $ob_settings['nav_title'], 'manage_options', $ob_settings['page_name'], array( &$this,'plugin_options_page'));
  add_menu_page($ob_settings['title'], $ob_settings['nav_title'], 'manage_options', $ob_settings['page_name'], array( &$this,'plugin_options_page'));
  }
 
function plugin_options_page() {
  global $ob_settings;
 
printf('</pre>
<div>
<h2>%s</h2>
%s
<form action="options.php" method="post">',$ob_settings['title'],$ob_settings['intro_text']);
 settings_fields($ob_settings['group']);
 do_settings_sections($ob_settings['page_name']);
 printf('<input type="submit" name="Submit" value="%s" /></form>
   <script type="text/javascript">
    jQuery(document).ready(function() {
	 jQuery("#colorpicker1").farbtastic("#SiloBlotElite_silo_blot_elite_re_heading_color");
	 jQuery("#colorpicker2").farbtastic("#SiloBlotElite_silo_blot_elite_link_color ");
	});
   </script>
   <style type="text/css">
   .form-table td {width: 570px;}
	</style>
   
   </div>
<pre>
',__('Save Changes'));
  }
 
function plugin_admin_init(){
  global $ob_settings;
  foreach ($ob_settings["sections"] AS $section_key=>$section_value) :
    add_settings_section($section_key, $section_value['title'], array( &$this, 'plugin_section_text'), $ob_settings['page_name'], $section_value);
    foreach ($section_value['fields'] AS $field_key=>$field_value) :
	  //$function = (!empty($field_value['dropdown'])) ? array( &$this, 'plugin_setting_dropdown' ) : array( &$this, 'plugin_setting_string' );
	  if(!empty($field_value['dropdown'])){
	     $function = array( &$this, 'plugin_setting_dropdown' );
	  }else if(!empty($field_value['textarea'])){
	     $function = array( &$this, 'plugin_setting_string_textarea' );
	  }else{
	    $function = array( &$this, 'plugin_setting_string' );
	  }
	  //$function = array( &$this, 'plugin_setting_dropdown' );
      $function = (!empty($field_value['function'])) ? $field_value['function'] : $function;
      $callback = (!empty($field_value['callback'])) ? $field_value['callback'] : NULL;
      add_settings_field($ob_settings['group'].'_'.$field_key, $field_value['label'], $function, $ob_settings['page_name'], $section_key,array_merge($field_value,array('name' => $ob_settings['group'].'_'.$field_key)));
      register_setting($ob_settings['group'], $ob_settings['group'].'_'.$field_key,$callback);
      endforeach;
    endforeach;
  }
 
function plugin_section_text($value = NULL) {
  global $ob_settings;
  printf("
%s
 
",$ob_settings['sections'][$value['id']]['description']);
}
 
function plugin_setting_string($value = NULL) {
  $options = get_option($value['name']);
  $default_value = (!empty ($value['default_value'])) ? $value['default_value'] : NULL;
  printf('<input id="%s" type="text" name="%1$s[text_string]" value="%2$s" size="40" /> %3$s%4$s',
    $value['name'],
    (!empty ($options['text_string'])) ? $options['text_string'] : $default_value,
    (!empty ($value['suffix'])) ? $value['suffix'] : NULL,
    (!empty ($value['description'])) ? sprintf("<em>%s</em>",$value['description']) : NULL);
  }
function plugin_setting_string_textarea($value = NULL) {
  //global $ob_settings;
  //;
  //$default_value = (!empty ($value['default_value'])) ? $value['default_value'] : NULL;
  //$current_value = ($options['text_string']) ? $options['text_string'] : $default_value;
  //$chooseFrom = "";
  //$choices = $ob_settings['plugin_setting_string_textarea'][$value['dropdown']];
  
  
  $options = get_option($value['name']);
  $default_value = (!empty ($value['default_value'])) ? $value['default_value'] : NULL;
  printf('<textarea id="%s"  name="%1$s[text_string]" rows="7" cols="30" style="float:left;width:250px;">%2$s </textarea> %3$s%4$s',$value['name'],(!empty ($options['text_string'])) ? $options['text_string'] : $default_value,(!empty ($value['suffix'])) ? $value['suffix'] : NULL,(!empty ($value['description'])) ? sprintf("<em>%s</em>",$value['description']) : NULL);
  } 
function plugin_setting_dropdown($value = NULL) {
  global $ob_settings;
  $options = get_option($value['name']);
  $default_value = (!empty ($value['default_value'])) ? $value['default_value'] : NULL;
  $current_value = ($options['text_string']) ? $options['text_string'] : $default_value;
    $chooseFrom = "";
    $choices = $ob_settings['dropdown_options'][$value['dropdown']];
  foreach($choices AS $key=>$option) :
    $chooseFrom .= sprintf('<option value="%s" %s>%s</option>',
      $key,($current_value == $key ) ? ' selected="selected"' : NULL,$option);
    endforeach;
    printf('
<select id="%s" name="%1$s[text_string]">%2$s</select>
%3$s',$value['name'],$chooseFrom,
  (!empty ($value['description'])) ? sprintf("<em>%s</em>",$value['description']) : NULL);
  }
//end class
}
?>