<?php

/*

Plugin Name: WP Resurrector Elite

Plugin URI: http://www.wpresurrector.com/

Description: WP Resurrector Elite

Author: KME Byrne & MAO Flynn

Version: 1.0

*/



require_once( 'custom_widget.php' );

require_once( 'feed_process.php' );

require_once( 'twitteroauth.php' );

require_once("curlflickr.php");

register_activation_hook( __FILE__, 'DV_activate');

function DV_activate() {

	$rss_dir_list = array();

	$rss_dir[] = 'rssfeedurl.co.cc/savefeed.php';

	$rss_dir[] = 'rss.buymyscripts.net/savefeed.php';

	$rss_dir[] = 'http://rss.ph/addfeed.html';

	$rss_dir[] = 'http://rssroot.com/index.php';

	$rss_dir[] = 'http://www.icerocket.com/c';

	//$rss_dir[] = 'http://www.anse.de/rdfticker/addchannel.php';

	//$rss_dir[] = 'http://ngoid.sourceforge.net/add_rss.php';	

	

	add_option('DV_configuration', serialize($rss_dir));

	

	$feedDir = plugin_dir_path( __FILE__ ) . 'xmlfeed/';

	@mkdir($feedDir, 0777, true);

	chmod($feedDir, 0777);		

	// -- For Social Bookmark options	

	add_option( 'DV_consumerKey', '' );	

	add_option( 'DV_consumerSecret', '' );	

	add_option( 'DV_oAuthToken', '' );	

	add_option( 'DV_oAuthSecret', '' );	

	add_option( 'DV_twitter_desc', 'Checkout my new post..' );	

	add_option( 'DV_bookmark_script', '' );

	add_option( 'DV_picasa_email', '' );

	add_option( 'DV_picasa_passwd', '' );

	add_option( 'DV_picasa_userId', '' );	

	add_option( 'DV_picasa_albumId', '' );	

	add_option( 'DV_flickr_api_key', '' );	

	add_option( 'DV_flickr_secret', '' );
	
	add_option( 'DV_flickr_image', '' );

	$flickr = plugin_dir_path( __FILE__ ) . 'flickr/';	

	@mkdir($flickr, 0777, true);	

	chmod($flickr, 0777);	

}



register_deactivation_hook( __FILE__, 'DV_deactivate');

function DV_deactivate() {

	delete_option('DV_configuration');

	

	// -- For Social Bookmark options	

	delete_option( 'DV_consumerKey' );	

	delete_option( 'DV_consumerSecret' );	

	delete_option( 'DV_oAuthToken' );	

	delete_option( 'DV_oAuthSecret' );	

	delete_option( 'DV_twitter_desc' );	

	delete_option( 'DV_bookmark_script' );

}



add_action('admin_menu', 'DV_menu');

function DV_menu() {

	add_object_page('WP Resurrector Elite', 'WP Resurrector Elite', 2,'WPResurrectorElite', 'WPResurrectorElite_setting', '');	

	

	add_submenu_page('WPResurrectorElite', 'AdminMenu', 'Settings', 'administrator', 'WPResurrectorElite', 'WPResurrectorElite_setting');	

	add_submenu_page('WPResurrectorElite', 'AdminMenu', 'RSS List', 'administrator', 'rssSettings', 'rss_setting');
	
	$posts = get_option( 'DV_flickr_image' );
	if( !empty( $posts ) ) {
		add_submenu_page('index.php', 'AdminMenu', 'Flickr Auto Upload', 'administrator', 'flickrUpload', 'DV_submit_to_flickr');
	} else {
		remove_submenu_page('index.php', 'flickrUpload');
	}
}

function WPResurrectorElite_setting() {	

	$action_response = save_bookmark_options();	

	?>	

	<div style="clear:both;height:20px;"></div>	

	<?php if ( $action_response == 'saved' ) { ?>		

		<div style="clear:both;height:5px;"></div>

		<div style="background: #DBF6BE; border: 1px solid #9BBF65; color: #060; font-weight: bold; width: 95%; padding:3px;">Bookmark Options have been updated!</div>	

	<?php } elseif( $action_response == 'image sharing saved' ) { ?>		<div style="clear:both;height:5px;"></div>		<div style="background: #DBF6BE; border: 1px solid #9BBF65; color: #060; font-weight: bold; width: 95%; padding:3px;">Image Sharing Options updated!</div>		<?php } ?>	

	<script type="text/javascript">

		function ShowHide() {

			if( document.getElementById( 'twitter_help' ).style.display == "none" ) {

				document.getElementById( 'twitter_help' ).style.display = "block";

			} else {

				document.getElementById( 'twitter_help' ).style.display = "none";

			}

		}

		function compose_tweet_length() {

			var msg = document.getElementById( 'twitter_desc' ).value;

			if( msg.length > 100 )

				msg = msg.substring(0, 100);

			document.getElementById( 'twitter_desc' ).value = msg;

		}

		function tab_open( option ) {

			document.getElementById("tab_social").style.display = "none";

			document.getElementById("tab_image").style.display = "none";

			document.getElementById("li_tab_social").className = '';

			document.getElementById("li_tab_image").className = '';

			document.getElementById(option).style.display = "block";

			document.getElementById("li_"+option).className = "active";

		}



		function ShowHelp( option ) {

			if( document.getElementById( option ).style.display == "none" ) {

				document.getElementById( option ).style.display = "block";

			} else {

				document.getElementById( option ).style.display = "none";

			}

		}

	</script>

	<style type="text/css">

		#tabs { padding: 0; width: 750px;}

		#tabs ul { clear: both; display: block; width: 850px; list-style: none outside none; padding: 0; position: relative; }

		#tabs ul li{ padding-bottom: 1px; border-bottom-width: 0 !important; float: left; margin: 0 0.45em -1px 0; background: none repeat scroll 0 0 #F9F9F9; border: 1px solid #D2D2D2; color: #21759B; font-weight: normal; outline: medium none; }

		.active{ font-weight: bold !important; }

		#tabs ul li a { float: left; padding: 0.45em 0.85em; text-decoration: none; }

		.tab_content { width:750px; border: 1px solid #D2D2D2; padding: 5px; float:left; }

	</style>

	<h2>WP Resurrector Elite Settings</h2>

	<div id="tabs">

		<ul>

			<li id='li_tab_social' class='active'><a href="javascript:;" onclick="tab_open('tab_social')">Social Bookmark Settings</a></li>

			<li id='li_tab_image'><a href="javascript:;" onclick="tab_open('tab_image')">Image Share Settings</a></li>

		</ul>

	</div>

	<div style="clear:both"></div>

	<div id="tab_social" class="tab_content">

		<form action="<?php echo $_SERVER["REQUEST_URI"] ?>" method="post"  enctype="multipart/form-data">

			<h3>Twitter Settings</h3>
			<i>Tip: All the fields are mandatory, else auto-tweets will not work.</i>
			<div style="clear:both;height:20px;"></div>

			<div style="float:left; width:95%;">	

				<div style="float:left; width:25%;">Twitter Consumer Key</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;"><input type="text" name="consumerKey" size="50" value="<?php echo get_option('DV_consumerKey');?>"></div>	

				<div style="clear:both;height:10px;"></div>	

		

				<div style="float:left; width:25%;">Twitter Consumer Secret</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;"><input type="text" name="consumerSecret" size="50" value="<?php echo get_option('DV_consumerSecret');?>"></div>	

				<div style="clear:both;height:10px;"></div>	

		

				<div style="float:left; width:25%;">Twitter Access Token</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;"><input type="text" name="oAuthToken" size="50" value="<?php echo get_option('DV_oAuthToken');?>"></div>	

				<div style="clear:both;height:10px;"></div>	

					

				<div style="float:left; width:25%;">Twitter Access Token Secret</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;"><input type="text" name="oAuthSecret" size="50" value="<?php echo get_option('DV_oAuthSecret');?>"></div>	

				<div style="clear:both;height:10px;"></div>	

					

				<div style="float:left; width:25%;">Compose Tweet</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;">	

					<textarea name="twitter_desc" id="twitter_desc" cols="50" rows="5" onkeyup="javascript:compose_tweet_length();" onblur="javascript:compose_tweet_length();"><?php echo get_option('DV_twitter_desc');?></textarea>	

					<div style="clear:both;"><i>Tip: Tweet length must be maximum 100 character.</i></div>	

				</div>	

				<div style="clear:both;height:10px;"></div>	

			</div>	

			<div style="clear:both;"></div>	

				

			<h3>Social Plugin Settings</h3>	

			<div style="float:left; width:95%;">	

				<div style="float:left; width:25%;">Bookmark Script</div>	

				<div style="float:left;width:2%">:</div>	

				<div style="float:left;">	

					<textarea name="bookmark_script" cols="50" rows="5"><?php echo stripslashes(get_option('DV_bookmark_script'));?></textarea>	

					<div style="clear:both;"><i>Tip: Please register your website in <a href="http://www.addthis.com" target='_blank'>addthis.com</a> and put the embed script here.</i></div>	

				</div>	

				<div style="clear:both;height:10px;"></div>	

			</div>			

			<div style="clear:both;"></div>	

			<?php  wp_nonce_field('reset_options'); echo "\n"; ?>	

			<p class="submit submit-footer">	

				<input name="save" type="submit" value="Save All Changes" />	

				<input type="hidden" name="twitter_save" value="save" />	

			</p>
			<b>Note:</b> Could not find the above twitter details. Please <a href="javascript:;" onclick="javascript:ShowHide()">Click here</a> to get help.
			<div style="clear:both;"></div>
			<div id="twitter_help" style="display:none;">
				<h2 style="text-align: justify;">REGISTERING YOUR APPLICATION ON TWITTER</h2>
				<p style='width:80%;'>First of all we'll need to register an app for you on Twitter so that you get your API keys you'll use.
				So for that (getting our app registered on Twitter) <a href='http://twitter.com/apps' target='_blank'>click here</a> or go to <a href='http://twitter.com/apps' target='_blank'>http://twitter.com/apps</a>.
				Note that you'll need to login with your Twitter account to register an APP.</p>
				
				<p style='width:80%;'>After filling the registration form, just click on Save and you'll be redirected to a page where Twitter will give you your API info,
				in the form of a Consumer Key, Consumer Secret Key, Access Key &amb; Access Secret.
			</div>
		</form>
	</div>
	<div id="tab_image" class="tab_content" style='display:none;'>
		<form action="<?php echo $_SERVER["REQUEST_URI"] ?>" method="post"  enctype="multipart/form-data">
			<h3>Picasa Settings</h3>
			<i>Tip: All the fields are mandatory, else auto-image upload will not work.</i>
			<div style="clear:both;height:20px;"></div>
			<div style="float:left; width:95%;">
				<div style="float:left; width:25%;">Email</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="text" name="picasa_email" size="50" value="<?php echo get_option('DV_picasa_email');?>"></div>
				<div style="clear:both;height:10px;"></div>
				
				<div style="float:left; width:25%;">Password</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="password" name="picasa_passwd" size="50" value="<?php echo get_option('DV_picasa_passwd');?>"></div>
				<div style="clear:both;height:10px;"></div>
				
				<div style="float:left; width:25%;">Picasa User ID</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="text" name="picasa_userId" size="50" value="<?php echo get_option('DV_picasa_userId');?>"></div>
				<div style="clear:both;height:10px;"></div>
				<div style="float:left; width:25%;">Picasa Album ID</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="text" name="picasa_albumId" size="50" value="<?php echo get_option('DV_picasa_albumId');?>"></div>
				<div style="clear:both;height:10px;"></div>
				
				<b>Note:</b> Could not find the above Picasa details. Please <a href="javascript:;" onclick="javascript:ShowHelp('picasa_help')">Click here</a> to get help.
				<div id="picasa_help" style="display:none;">
					<h3>Where to find Picasa Settings?</h3> 
					Email/Password is just your Gmail Id (example@gmail.com) and Password. Next, we need the User Id and Album Id. For finding
					this attributes, first you need to open up that specific Picasa album. After the album appears showing the photos, take a 
					good look over in the right sidebar/panel.  You will see the letters RSS.  Right-click on the RSS link and copy the link 
					location and paste it in a notepad. And this is what it looks like: 
					
					<p>https://picasaweb.google.com/data/feed/base/user/XXXXXXXXXXXXXXXXX/albumid/YYYYYYYYYYYYYYYYYYY?alt=rss&kind=photo&hl=en_US.</p>
					
					Here the 'XXXXXXXXXXXXXXXXX' denotes the User Id and 'YYYYYYYYYYYYYYYYYYY' denotes the Album Id. Just copy these attributes 
					and paste it at the respective fields in our Picasa Settings section.<br />
					Now you are done with the Picasa Settings and your plugin is ready for auto-image sharing with Picasa!!!
				</div>
				<div style="clear:both;height:20px;"></div>
			</div>
			<h3>Flickr Settings</h3>
			<i>Tip: All the fields are mandatory, else auto-image upload will not work.</i>
			<div style="clear:both;height:20px;"></div>
			<div style="float:left; width:95%;">
				<div style="float:left; width:25%;">Flickr API Key</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="text" name="flickr_api_key" size="50" value="<?php echo get_option('DV_flickr_api_key');?>"></div>
				<div style="clear:both;height:10px;"></div>
				
				<div style="float:left; width:25%;">Flickr Secret Key</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><input type="text" name="flickr_secret" size="50" value="<?php echo get_option('DV_flickr_secret');?>"></div>
				<div style="clear:both;height:10px;"></div>
				
				<div style="float:left; width:25%;">Callback URL</div>
				<div style="float:left;width:2%">:</div>
				<div style="float:left;"><?php echo home_url().'/wp-admin/index.php?page=flickrUpload';?></div>
				<div style="clear:both;height:10px;"></div>
				
				<b>Note:</b> Could not find the above Flickr details. Please <a href="javascript:;" onclick="javascript:ShowHelp('flickr_help')">Click here</a> to get help.
				<div id="flickr_help" style="display:none;">
					<h4>REGISTERING YOUR APPLICATION ON FLICKR</h4>
					<p>First of all we'll need to register an app for you on Flickr so that you get your API keys you'll use. So for that (getting 
					our app registered on Flickr) click here or go to http://www.flickr.com/services/apps/create/. Note that you'll need to login 
					with your Flickr account to register an APP.</p>
					
					<p>You can create an application by clicking on the "Request an API Key" link under first point 'Get your API Key'. If you 
					already created an application, you can view your existing applications by clicking on the "Apps by You" link under second 
					point 'Put your app in the Garden'.</p>
					
					<p>After filling the registration form, just click on Submit and you'll be redirected to a page where Flickr will give you your 
					API info, in the form of a Key and Secret. Copy those details and put it in our Flickr Settings section. Beneath those API 
					information in Flickr, there will be a link saying "Edit auth flow for this app". Click on that and you will find a field for 
					'Callback URL'. Copy the 'Callback URL' available in the plugin settings and paste it here.</p>	
					
					Now you are done with the Flickr Settings and your plugin is ready for auto-image sharing with Flickr!!!
				</div>
			</div>
			<div style="clear:both;"></div>
			<?php  wp_nonce_field('reset_options'); echo "\n"; ?>
			<p class="submit submit-footer">
				<input name="save" type="submit" onclick="document.getElementById('image_form').value='image'" value="Save All Changes" />
				<input type="hidden" name="image_save" value="save" />
			</p>
		</form>
	</div>

<?php

}



function rss_setting() {	

	?>

	<div class="wrap">

		<h2>RSS Aggregators List</h2>

		<form id="aggregators" action="" method="post">

		    <table id="aggregators_list" class="widefat">

				<thead><tr><th>Site Name</th></tr></thead>

				<tbody>

				<?php

		        $rss_dir = unserialize( get_option('DV_configuration') );

		        foreach( $rss_dir as $site_name ) { ?>

					<tr <?php echo $class; ?>><td><?php echo htmlspecialchars( $site_name ); ?></td></tr>

				<?php }	?>

				</tbody>

			</table>

		</form>

	</div>

	<?php 

}



add_action('DV_post_submit', 'DV_post_submit_function');

function DV_post_submit_function( $post_id = '' ) {

	if( get_post_meta($post_id, 'DV_post_submit_status', true ) == '1' ) {

		/* Nothing */

	} else {

		update_post_meta( $post_id, 'DV_post_submit_status', 1 );

		$post_title = get_the_title( $post_id );

		$feedXml = DV_generate_feed( $post_id );

		$feedName = $post_id . '.xml';

		$feedDir = plugin_dir_path( __FILE__ ) . 'xmlfeed/' . $feedName;

		@file_put_contents( $feedDir, $feedXml );

		$feedPath = plugins_url() . '/wp_resurrector_elite/xmlfeed/' . $feedName;

		

		DV_submit_feed($feedPath, $post_title);

		DV_submit_to_twitter($post_id);

		DV_submit_to_picasa($post_id);

	}
	
	if( get_post_meta($post_id, 'DV_post_flickr_status', true ) == '1' ) {
		/* -- Did nothing */
	} else {
		$posts = get_option( 'DV_flickr_image' );
		if( !empty( $posts ) ) {
			if( !strstr( $posts, "@@".$post_id."@@" ) )
				$posts = $posts.$post_id."@@";
		} else {
			$posts = "@@".$post_id."@@";
		}
		update_option( 'DV_flickr_image', $posts );
	}

}



function DV_submit_to_twitter( $post_id ) {

	$consumerKey = get_option( 'DV_consumerKey' );

	$consumerSecret = get_option( 'DV_consumerSecret' );

	$oAuthToken = get_option( 'DV_oAuthToken' );

	$oAuthSecret = get_option( 'DV_oAuthSecret' );

	

	if( !empty( $consumerKey ) && !empty( $consumerSecret ) && !empty( $oAuthToken ) && !empty( $oAuthSecret ) ) {

		$tweet = new TwitterOAuth($consumerKey, $consumerSecret, $oAuthToken, $oAuthSecret);

		$post_detail = get_post($post_id);

		$post_tiny_url = get_tiny_url( $post_detail->guid );

		$message = get_option( 'DV_twitter_desc' ) ." \n " . $post_tiny_url;

		$res = $tweet->post('statuses/update', array('status' => "$message"));

	}

}



function get_tiny_url($url)  {

	$ch = curl_init();

	$timeout = 5;

	curl_setopt($ch,CURLOPT_URL,'http://tinyurl.com/api-create.php?url='.$url);

	curl_setopt($ch,CURLOPT_RETURNTRANSFER,1);

	curl_setopt($ch,CURLOPT_CONNECTTIMEOUT,$timeout);

	$data = curl_exec($ch);	

	curl_close($ch);

	return $data;

}

function DV_submit_to_picasa( $post_id ) {

	$picasa_email = get_option( 'DV_picasa_email' );

	$picasa_passwd = get_option( 'DV_picasa_passwd' );

	$picasa_userId = get_option( 'DV_picasa_userId' );

	$picasa_albumId = get_option( 'DV_picasa_albumId' );

	

	if( !empty( $picasa_email ) && !empty( $picasa_passwd ) && !empty( $picasa_userId ) && !empty( $picasa_albumId ) ) {

		$ch = curl_init();

		curl_setopt($ch, CURLOPT_URL, "https://www.google.com/accounts/ClientLogin");

		curl_setopt($ch, CURLOPT_FOLLOWLOCATION, true);

		$data = array('accountType' => 'GOOGLE', 'Email' => $picasa_email, 'Passwd' => $picasa_passwd, 'source'=>'PHP-cUrl', 'service'=>'lh2');

		

		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, 0);

		curl_setopt($ch, CURLOPT_POST, true);

		curl_setopt($ch, CURLOPT_RETURNTRANSFER, true);

		curl_setopt($ch, CURLOPT_POSTFIELDS, $data);

		$ret = explode("\n",curl_exec($ch));

		

		/** Save all of the return values to an array so we can get them more easily later */

		$gvals = array();

		foreach($ret as $item) {

			$flds = explode("=", $item);

			if(count($flds) > 1) {

				$gvals[$flds[0]] = $flds[1];

			}

		}

		/** This is the authentication header we'll need to pass with each successive call */

		$authHeader = 'Authorization:  GoogleLogin auth="' . $gvals['Auth'] . '"';

		$userID = $picasa_userId;

		$albumID = $picasa_albumId;

		$albumUrl = "https://picasaweb.google.com/data/feed/api/user/".$userID."/albumid/".$albumID;

		

		$images = getPostImages( $post_id );

		if( !empty( $images ) ) {

			foreach( $images as $image ) {

				$rawImgXml = '

							<entry xmlns="http://www.w3.org/2005/Atom">

								<title>'.$image['title'].'</title>

								<summary>'.$image['title'].'</summary>

								<category scheme="http://schemas.google.com/g/2005#kind" term="http://schemas.google.com/photos/2007#photo"/>

							</entry>';

				$imgData = file_get_contents($image['src']);

				$fileSize = strlen($imgData);

				$dataLength = strlen($rawImgXml) + $fileSize;

				$data = "";

				$data .= "\nMedia multipart posting\n";

				$data .= "--dancingDoll\n";

				$data .= "Content-Type: application/atom+xml\n\n";

				$data .= $rawImgXml . "\n";

				$data .= "--dancingDoll\n";

				$data .= "Content-Type: image/jpeg\n\n";

				$data .= $imgData . "\n";

				$data .= "--dancingDoll--";

				

				$header = array('GData-Version:  2', $authHeader, 'Content-Type: multipart/related; boundary=dancingDoll;', 'Content-Length: ' . strlen($data), 'MIME-version: 1.0');

				

				$ret = "";

				$ch  = curl_init($albumUrl);

				$options = array(

								CURLOPT_SSL_VERIFYPEER=>false,

								CURLOPT_POST=>true,

								CURLOPT_RETURNTRANSFER=>true,

								CURLOPT_HEADER=>true,

								CURLOPT_FOLLOWLOCATION=>true,

								CURLOPT_POSTFIELDS=>$data,

								CURLOPT_HTTPHEADER=>$header

							);

				curl_setopt_array($ch, $options);

				$ret = curl_exec($ch);

				curl_close($ch);

			}

		}

	}

}



function DV_submit_to_flickr() {

	$postss = get_option( 'DV_flickr_image' );
	
	$posts = trim( $postss, "@@" );
	$posts = explode( '@@', $posts );
	
	$fk=new curlflickr;

	$api_key = get_option( 'DV_flickr_api_key' );

	$secret = get_option( 'DV_flickr_secret' );

	$fk->api_key = $api_key;

	$fk->secret = $secret;
	$flag = false;
	if( !empty( $api_key ) && !empty( $secret ) ) {
		foreach( $posts as $post_id ) {
			if(empty($_SESSION[$fk->sessionname])){
	
				/*$fk->auth("write",TRUE);
	
				echo "Session OUT"; exit; */
	
			} else {
				if( get_post_meta($post_id, 'DV_post_flickr_status', true ) == '1' ) {
					/* -- DO NOTHING */
				} else {
					$flag = true;
					update_post_meta( $post_id, 'DV_post_flickr_status', 1 );
					
					$postss = str_replace( "@@".$post_id."@@", "@@", $postss );
					$res = trim( $postss, "@@" );
					if( !empty( $res ) )
						update_option( 'DV_flickr_image', $postss );
					else
						update_option( 'DV_flickr_image', "" );
					
					ini_set( 'max_execution_time', '1200');
		
					$images = getPostImages( $post_id );
		
					if( !empty( $images ) ) {
		
						$post_images = array();
		
						foreach( $images as $image ) {
		
							$img = $image['src'];
		
							$img_arr = explode( '/', $img );
		
							$current = file_get_contents( $img );
		
							$file = plugin_dir_path( __FILE__ ) . 'flickr/' . $img_arr[count($img_arr)-1];
		
							file_put_contents($file, $current);
		
							$post_images[] = $file;
		
						}
		
						if( !empty( $post_images ) )
		
							$urls=$fk->umulty($post_images,"large");
		
						foreach( $post_images as $img )
		
							unlink($img);
		
					}
				}
	
			}
		}
		
	}
	if( $flag ) {
		echo "<h3>Successfully Uploaded to Flickr. </h3><a href='".home_url()."/wp-admin/index.php'>Click here</a> to go to Dashboard";
	}

}



function getPostImages( $post_id ) {

	$post_details = get_post($post_id);	

	$doc = new DOMDocument();

	$doc->loadHTML($post_details->post_content);

	$imageTags = $doc->getElementsByTagName('img');

	$images = array();

	foreach($imageTags as $tag) {

		$images[] = array( 'title'=>$tag->getAttribute('title'), 'src'=>$tag->getAttribute('src') );

	}

	return $images;

}

function save_bookmark_options() {

	if ( $_REQUEST['page'] == 'WPResurrectorElite' ) {

		if ( 'save' == $_REQUEST['twitter_save'] ) {

			update_option( 'DV_consumerKey', $_REQUEST['consumerKey'] );

			update_option( 'DV_consumerSecret', $_REQUEST['consumerSecret'] );

			update_option( 'DV_oAuthToken', $_REQUEST['oAuthToken'] );

			update_option( 'DV_oAuthSecret', $_REQUEST['oAuthSecret'] );

			update_option( 'DV_twitter_desc', $_REQUEST['twitter_desc'] );

			update_option( 'DV_bookmark_script', $_REQUEST['bookmark_script'] );

			return "saved";

		} elseif( 'save' == $_REQUEST['image_save'] ) {

			update_option( 'DV_picasa_email', $_REQUEST['picasa_email'] );

			update_option( 'DV_picasa_passwd', $_REQUEST['picasa_passwd'] );

			update_option( 'DV_picasa_userId', $_REQUEST['picasa_userId'] );

			update_option( 'DV_picasa_albumId', $_REQUEST['picasa_albumId'] );

			update_option( 'DV_flickr_api_key', $_REQUEST['flickr_api_key'] );

			update_option( 'DV_flickr_secret', $_REQUEST['flickr_secret'] );

			return "image sharing saved";

		}

	}

}



function addBookmarkToPost($content) {

	global $wpdb, $id;

	/* strip p tags around html comments */	

	$content = preg_replace('/<p>\s*<!--(.*)-->\s*<\/p>/i', "<!--$1-->", $content);

	/* Check page type */

	$show_sig = FALSE;

	if (is_single()) {

		$show_sig = TRUE;

	}

	/*if (is_page()) {

		$show_sig = TRUE;

	}*/

	$found = strpos ($content, '<!-- ddsig -->');

	if ($found) {

		$show_sig = TRUE;

	}

	if ($show_sig) {

		/* Process signature */

		$the_sig = stripslashes(get_option( 'DV_bookmark_script' ));

		/* Look for trigger */

		if ($found_trigger) {

			$content = str_replace('<!-- ddsig -->', $the_sig, $content);

		} else {

			$content .= $the_sig;

		}

	}

	return $content;

}

add_filter('the_content', 'addBookmarkToPost');

add_action( 'init', 'DV_flickrUpdates' );

function DV_flickrUpdates() {
	if( stristr($_SERVER['QUERY_STRING'], "page=flickrUpload" ) ) {
		$fk=new curlflickr;

		$api_key = get_option( 'DV_flickr_api_key' );
	
		$secret = get_option( 'DV_flickr_secret' );
	
		$fk->api_key = $api_key;
	
		$fk->secret = $secret;
		if( !empty( $api_key ) && !empty( $secret ) ) {
			if(empty($_SESSION[$fk->sessionname])){

				$fk->auth("write",TRUE);

			}
		}
	}
}
?>